#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int main()
{
int n,m,iossz=0,jossz=0;
cin>>n>>m;
vector<pair<int,int>> A,B;
vector<pair<pair<int,int>,int>> eredmeny;
pair<int,int> C;
pair<pair<int,int>,int> D;
int Tomb[n+1][m+1];
for(int i=0;i<n;i++)
{
    int a,b;
    cin>>a>>b;
    C.first=a;
    C.second=b;
    iossz+=b;
    A.push_back(C);
}
for(int i=0;i<m;i++)
{
    int a,b;
    cin>>a>>b;
    jossz+=b;
    C.first=a;
    C.second=b;
    B.push_back(C);
}
cout<<min(jossz,iossz)<<endl;
int i=0,j=0;
while(jossz!=0&&iossz!=0)
{
    int Min=min(A[i].second,B[j].second);
    C.first=i+1;
    C.second=j+1;
    D.first=C;
    D.second=Min;
    eredmeny.push_back(D);
    jossz-=Min;
    iossz-=Min;
    if(A[i].second>B[j].second)
    {
        j++;
    }
    else
        if(A[i].second<B[j].second)
    {
        i++;
    }
    else
    {
        i++;
        j++;
    }

}
cout<<eredmeny.size()<<endl;
for(int i=0;i<eredmeny.size();i++)
{
    cout<<eredmeny[i].first.first<<" "<<eredmeny[i].first.first<<" "<<eredmeny[i].second<<endl;
}
}